import { SchemaOptions } from './Schema';
import Database from './database/Database';
import OrqlToSql from './sql/OrqlToSql';
import SchemaManager from './SchemaManager';
import BaseDialect from './dialect/BaseDialect';
import Migration from './migration/Migration';
import OrqlResultMapper from './mapper/OrqlResultMapper';
import ResultMapper from './mapper/ResultMapper';
export interface ConfigurationOptions {
    schemas?: SchemaOptions[];
    dialect?: 'mysql' | 'sqlite3';
    connection?: ConnectionOptions;
}
export interface ConnectionOptions {
    host?: string;
    database?: string;
    username?: string;
    password?: string;
    port?: number;
    path?: string;
}
declare class Configuration {
    readonly schemaManager: SchemaManager;
    readonly database?: Database;
    readonly dialect?: BaseDialect;
    readonly orqlToSql: OrqlToSql;
    readonly migration?: Migration;
    readonly resultMapper: ResultMapper;
    readonly orqlResultMapper: OrqlResultMapper;
    readonly connectionOptions?: ConnectionOptions;
    constructor(options: ConfigurationOptions);
}
export { SchemaManager };
export default Configuration;
