"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class NativeBuilder {
    constructor(session) {
        this._params = {};
        this.session = session;
    }
    sql(sql) {
        this._sql = sql;
        return this;
    }
    param(key, value) {
        this._params[key] = value;
        return this;
    }
    params(params) {
        this._params = params;
        return this;
    }
    mapper(mapper) {
        this._mapper = mapper;
        return this;
    }
    async queryAll() {
        const { results } = await this.session.nativeQuery(this._sql, this._params);
        if (this._mapper) {
            return this.session.resultMapper.mappe(this._mapper, results);
        }
        return results;
    }
    async queryOne() {
        const results = await this.queryAll();
        if (results.length > 0)
            return results[0];
    }
    update() {
        return this.session.nativeUpdate(this._sql, this._params);
    }
}
exports.default = NativeBuilder;
