import Configuration, { ConfigurationOptions } from './Configuration';
import Session from './Session';
import Schema, { SchemaOptions } from './Schema';
import { Columns } from './SchemaManager';
export default class OrqlExecutor {
    readonly configuration: Configuration;
    constructor(options: ConfigurationOptions);
    newSession(): Promise<Session>;
    /**
     * add schema
     * @param name  schema name
     * @param columns columns data type or column options or association options
     * @param options
     */
    addSchema(name: any, columns: Columns, options?: SchemaOptions): Schema;
    getSchema(name: any): Schema | undefined;
    removeSchema(name: string): void;
    sync(type: 'create' | 'update' | 'drop'): Promise<void>;
}
