import Schema, { AssociationOptions, ColumnOptions, DataType, SchemaOptions } from './Schema';
export declare type Columns = {
    [name: string]: ColumnOptions | DataType | AssociationOptions;
};
export default class SchemaManager {
    readonly schemas: Schema[];
    private addAssociationMap;
    getSchema(name: string): Schema | undefined;
    hasSchema(name: string): boolean;
    addSchema(name: string, columns: Columns, options?: SchemaOptions): Schema;
    removeSchema(name: string): void;
    toJSON(): Schema[];
}
