"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
const sqlite3 = __importStar(require("sqlite3"));
sqlite3.verbose();
class Sqlite3Connection {
    constructor(options) {
        const { path } = options;
        this.db = new sqlite3.Database(path);
    }
    add(namedParamSql) {
        return new Promise((resolve, reject) => {
            console.log(namedParamSql.toString());
            this.db.run(namedParamSql.sql, namedParamSql.getParamArray(), function (err) {
                if (err) {
                    reject(err);
                    return;
                }
                resolve(this.lastID);
            });
        });
    }
    async beginTransaction() {
        return new Promise((resolve, reject) => {
            this.db.run('begin transaction', function (err) {
                if (err) {
                    reject(err);
                    return;
                }
                resolve();
            });
        });
    }
    async close() {
        return new Promise((resolve, reject) => {
            this.db.close(err => {
                if (err) {
                    reject(err);
                    return;
                }
                resolve();
            });
        });
    }
    async commit() {
        return new Promise((resolve, reject) => {
            this.db.run('commit transaction', function (err) {
                if (err) {
                    reject(err);
                    return;
                }
                resolve();
            });
        });
    }
    async delete(namedParamSql) {
        return await this.update(namedParamSql);
    }
    async query(namedParamSql) {
        console.log(namedParamSql.toString());
        return new Promise((resolve, reject) => {
            this.db.all(namedParamSql.sql, namedParamSql.getParamArray(), ((err, rows) => {
                if (err)
                    return reject(err);
                const fields = rows.length > 0 ? Object.keys(rows[0]) : [];
                const results = rows.map(row => {
                    const obj = {};
                    for (const field of fields) {
                        obj[field] = row[field];
                    }
                    return obj;
                });
                resolve({
                    fields,
                    results
                });
            }));
        });
    }
    async rollback() {
        return new Promise((resolve, reject) => {
            this.db.run('rollback transaction', function (err) {
                if (err) {
                    reject(err);
                    return;
                }
                resolve();
            });
        });
    }
    update(namedParamSql) {
        console.log(namedParamSql.toString());
        return new Promise((resolve, reject) => {
            this.db.run(namedParamSql.sql, namedParamSql.getParamArray(), function (err) {
                if (err) {
                    reject(err);
                    return;
                }
                resolve(this.changes);
            });
        });
    }
}
module.exports = class Sqlite3 {
    async getConnect(options) {
        return new Sqlite3Connection(options);
    }
};
