import SqlNode, { SqlColumn, SqlCompareOp, SqlDelete, SqlExp, SqlForm, SqlInsert, SqlJoin, SqlLogicOp, SqlOrder, SqlPage, SqlParam, SqlQuery, SqlTable, SqlUpdate, SqlValue } from '../sql/SqlNode';
export default class BaseDialect {
    gen(node: SqlNode): string;
    protected genQuery(sqlQuery: SqlQuery): string;
    protected genSelect(select: Array<SqlColumn>): string;
    protected genSelectColumn(column: SqlColumn): string;
    protected genFrom(from: SqlForm): string;
    protected genFromSqlTable(sqlTable: SqlTable): string;
    protected genJoins(joins: Array<SqlJoin>): string;
    protected genJoin(join: SqlJoin): string;
    protected genExp(exp: SqlExp): string;
    protected genColumn(column: SqlColumn): string;
    protected genParam(param: SqlParam): string;
    protected genValue(right: SqlValue): string;
    protected genCompareOp(op: SqlCompareOp): string;
    protected genLogicOp(op: SqlLogicOp): string;
    protected genWhere(where: Array<SqlExp>): string;
    protected genOrders(orders: Array<SqlOrder>): string;
    protected genPage(page: SqlPage): string;
    protected genInsert(insert: SqlInsert): string;
    protected genUpdate(update: SqlUpdate): string;
    protected genDelete(node: SqlDelete): string;
}
