"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Schema_1 = require("./Schema");
exports.DataType = Schema_1.DataType;
const OrqlExecutor_1 = __importDefault(require("./OrqlExecutor"));
exports.OrqlExecutor = OrqlExecutor_1.default;
function intPkAndGk() {
    return { type: Schema_1.DataType.Int, primaryKey: true, generatedKey: true };
}
exports.intPkAndGk = intPkAndGk;
function longPkAndGk() {
    return { type: Schema_1.DataType.Long, primaryKey: true, generatedKey: true };
}
exports.longPkAndGk = longPkAndGk;
function belongsTo(refName, options) {
    return Object.assign({ type: Schema_1.AssociationType.BelongsTo, refName }, options);
}
exports.belongsTo = belongsTo;
function hasMany(refName, options) {
    return Object.assign({ type: Schema_1.AssociationType.HasMany, refName }, options);
}
exports.hasMany = hasMany;
function hasOne(refName, options) {
    return Object.assign({ type: Schema_1.AssociationType.HasOne, refName }, options);
}
exports.hasOne = hasOne;
function belongsToMany(refName, middleName, options) {
    return Object.assign({ type: Schema_1.AssociationType.BelongsToMany, refName, middleName }, options);
}
exports.belongsToMany = belongsToMany;
exports.default = OrqlExecutor_1.default;
