import { DataType } from '../Schema';
export declare class ResultRoot {
    readonly id?: ResultId;
    readonly columns: ResultItem[];
    constructor(id: ResultId, columns: Array<ResultItem>);
}
export declare class ResultItem {
    readonly column: string;
    constructor(column: string);
}
export declare class ResultColumn extends ResultItem {
    readonly field: string;
    readonly type?: DataType;
    constructor(column: string, type?: DataType, field?: string);
}
export declare class ResultId extends ResultColumn {
}
export declare class ResultRef extends ResultItem {
    readonly root: ResultRoot;
    constructor(column: string, root: ResultRoot);
}
export declare class ResultObject extends ResultRef {
}
export declare class ResultArray extends ResultRef {
}
export default class ResultMapper {
    mappe(resultRoot: ResultRoot, results: any[]): any[];
}
