import { DatabaseColumn, DatabaseFK } from './Migration';
import Session from '../Session';
import Schema, { Column } from '../Schema';
declare const _default: {
    new (): {
        create(session: Session): Promise<void>;
        createTable(session: Session, schema: Schema): Promise<void>;
        renameTable(session: Session, oldName: string, newName: string): Promise<void>;
        dropTable(session: Session, name: string): Promise<void>;
        addColumn(session: Session, schema: Schema, column: Column): Promise<void>;
        updateColumn(session: Session, schema: Schema, column: Column, oldField?: string | undefined): Promise<void>;
        genFK(schema: Schema, column: Column): string;
        genCreateColumn(column: Column): string;
        genColumnType(column: Column, type: "query" | "create"): string;
        genColumnTypeAndLength(column: Column): string;
        drop(session: Session): Promise<void>;
        update(session: Session): Promise<void>;
        updateFks(session: Session, schema: Schema): Promise<void>;
        existsTable(session: Session, name: string): Promise<boolean>;
        queryAllColumn(session: Session, schema: Schema): Promise<DatabaseColumn[]>;
        queryColumn(session: Session, schema: Schema, column: Column): Promise<DatabaseColumn | undefined>;
        getDatabaseColumn(result: any): DatabaseColumn;
        getDatabaseFKColumn(result: any): DatabaseFK;
        shouldUpdateColumn(column: Column, databaseColumn: DatabaseColumn): boolean;
        shouldUpdateFK(column: Column, fkColumn: DatabaseFK): boolean;
        getTypeAndLength(type: string): [string, (number | undefined)?];
        addFK(session: Session, schema: Schema, column: Column): Promise<void>;
        queryFK(session: Session, schema: Schema, column: Column): Promise<DatabaseFK | undefined>;
        updateFK(session: Session, schema: Schema, column: Column): Promise<void>;
        queryAllFK(session: Session, schema: Schema): Promise<DatabaseFK[]>;
        dropFK(session: Session, schema: Schema, column: Column): Promise<void>;
    };
};
export = _default;
