import { DatabaseColumn, DatabaseFK } from './Migration';
import Session from '../Session';
import Schema, { Column } from '../Schema';
declare const _default: {
    new (): {
        create(session: Session): Promise<void>;
        createTable(session: Session, schema: Schema): Promise<void>;
        genCreateColumn(column: Column): string;
        genColumnType(column: Column): string;
        renameTable(session: Session, oldName: string, newName: string): Promise<void>;
        drop(session: Session): Promise<void>;
        existsTable(session: Session, name: string): Promise<boolean>;
        dropTable(session: Session, name: string): Promise<void>;
        update(session: Session): Promise<void>;
        addColumn(session: Session, schema: Schema, column: Column): Promise<void>;
        addFKColumn(session: Session, schema: Schema, column: Column): Promise<void>;
        queryAllColumn(session: Session, schema: Schema): Promise<DatabaseColumn[]>;
        queryColumn(session: Session, schema: Schema, column: Column): Promise<DatabaseColumn | undefined>;
        shouldUpdateColumn(column: Column, databaseColumn: DatabaseColumn): boolean;
        updateColumn(session: Session, schema: Schema, column: Column, oldField?: string | undefined): Promise<undefined>;
        addFK(session: Session, schema: Schema, column: Column): Promise<void>;
        queryFK(session: Session, schema: Schema, column: Column): Promise<DatabaseFK | undefined>;
        shouldUpdateFK(column: Column, fkColumn: DatabaseFK): boolean;
        updateFK(session: Session, schema: Schema, column: Column): Promise<void>;
        dropFK(session: Session, schema: Schema, column: Column): Promise<void>;
    };
};
export = _default;
