import { OrqlNode } from 'orql-parser/lib/OrqlNode';
import BaseDialect from '../dialect/BaseDialect';
import SchemaManager from '../SchemaManager';
import { Params } from './NamedParamSql';
export default class OrqlToSql {
    private sqlCaches;
    private schemaManager;
    private dialect;
    constructor(schemaManager: SchemaManager, dialect: BaseDialect);
    toQuery(node: OrqlNode, options?: {
        offset?: number;
        limit?: number;
    }): string;
    private toExp;
    private toLogicOp;
    private toCompareOp;
    toAdd(node: OrqlNode, params?: Params): string;
    toUpdate(node: OrqlNode): string;
    toDelete(node: OrqlNode): string;
}
