"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SqlNode {
}
exports.default = SqlNode;
/**
 * 数据操作
 */
class SqlDML extends SqlNode {
}
exports.SqlDML = SqlDML;
class SqlInsert extends SqlDML {
    constructor(table, columns, params) {
        super();
        this.table = table;
        this.columns = columns;
        this.params = params;
    }
}
exports.SqlInsert = SqlInsert;
class SqlDelete extends SqlDML {
    constructor(table, where) {
        super();
        this.table = table;
        this.where = where;
    }
}
exports.SqlDelete = SqlDelete;
class SqlUpdate extends SqlDML {
    constructor(table, where, sets) {
        super();
        this.table = table;
        this.where = where;
        this.sets = sets;
    }
}
exports.SqlUpdate = SqlUpdate;
class SqlQuery extends SqlDML {
    constructor(select, from, where, joins, orders, page) {
        super();
        this.select = select;
        this.from = from;
        this.where = where;
        this.joins = joins;
        this.page = page;
        this.orders = orders;
    }
}
exports.SqlQuery = SqlQuery;
class SqlExp {
}
exports.SqlExp = SqlExp;
class SqlLogicExp extends SqlExp {
    constructor(left, op, right) {
        super();
        this.left = left;
        this.op = op;
        this.right = right;
    }
}
exports.SqlLogicExp = SqlLogicExp;
class SqlColumnExp extends SqlExp {
    constructor(left, op, right) {
        super();
        this.left = left;
        this.op = op;
        this.right = right;
    }
}
exports.SqlColumnExp = SqlColumnExp;
class SqlNestExp extends SqlExp {
    constructor(exp) {
        super();
        this.exp = exp;
    }
}
exports.SqlNestExp = SqlNestExp;
class SqlParam {
    constructor(name) {
        this.name = name;
    }
}
exports.SqlParam = SqlParam;
class SqlValue {
    constructor(value) {
        this.value = value;
    }
}
exports.SqlValue = SqlValue;
var SqlCompareOp;
(function (SqlCompareOp) {
    SqlCompareOp[SqlCompareOp["Ge"] = 0] = "Ge";
    SqlCompareOp[SqlCompareOp["Gt"] = 1] = "Gt";
    SqlCompareOp[SqlCompareOp["Eq"] = 2] = "Eq";
    SqlCompareOp[SqlCompareOp["Le"] = 3] = "Le";
    SqlCompareOp[SqlCompareOp["Lt"] = 4] = "Lt";
    SqlCompareOp[SqlCompareOp["Ne"] = 5] = "Ne";
    SqlCompareOp[SqlCompareOp["Like"] = 6] = "Like";
})(SqlCompareOp = exports.SqlCompareOp || (exports.SqlCompareOp = {}));
var SqlLogicOp;
(function (SqlLogicOp) {
    SqlLogicOp[SqlLogicOp["And"] = 0] = "And";
    SqlLogicOp[SqlLogicOp["Or"] = 1] = "Or";
})(SqlLogicOp = exports.SqlLogicOp || (exports.SqlLogicOp = {}));
class SqlColumn {
    constructor(name, table) {
        this.name = name;
        this.table = table;
    }
}
exports.SqlColumn = SqlColumn;
class SqlCountColumn extends SqlColumn {
}
exports.SqlCountColumn = SqlCountColumn;
class SqlSet {
    constructor(name, param) {
        this.name = name;
        this.param = param;
    }
}
exports.SqlSet = SqlSet;
class SqlForm {
}
exports.SqlForm = SqlForm;
class SqlTableForm extends SqlForm {
    constructor(table) {
        super();
        this.table = table;
    }
}
exports.SqlTableForm = SqlTableForm;
class SqlInnerFrom extends SqlForm {
    constructor(query) {
        super();
        this.query = query;
    }
}
exports.SqlInnerFrom = SqlInnerFrom;
class SqlJoin {
    constructor(table, alias, type, on) {
        this.table = table;
        this.alias = alias;
        this.type = type;
        this.on = on;
    }
}
exports.SqlJoin = SqlJoin;
var SqlJoinType;
(function (SqlJoinType) {
    SqlJoinType[SqlJoinType["Inner"] = 0] = "Inner";
    SqlJoinType[SqlJoinType["Left"] = 1] = "Left";
})(SqlJoinType = exports.SqlJoinType || (exports.SqlJoinType = {}));
class SqlPage {
    constructor(offset, limit) {
        this.offset = offset;
        this.limit = limit;
    }
}
exports.SqlPage = SqlPage;
class SqlOrder {
    constructor(sort, columns) {
        this.sort = sort;
        this.columns = columns;
    }
}
exports.SqlOrder = SqlOrder;
class SqlTable {
    constructor(name, alias = name) {
        this.name = name;
        this.alias = alias;
    }
}
exports.SqlTable = SqlTable;
